git-filter-branch.shon commit Merge gitk changes from Paul Mackerras at git://ozlabs.org/~paulus/gitk (b476064)
   1#!/bin/sh
   2#
   3# Rewrite revision history
   4# Copyright (c) Petr Baudis, 2006
   5# Minimal changes to "port" it to core-git (c) Johannes Schindelin, 2007
   6#
   7# Lets you rewrite the revision history of the current branch, creating
   8# a new branch. You can specify a number of filters to modify the commits,
   9# files and trees.
  10
  11# The following functions will also be available in the commit filter:
  12
  13functions=$(cat << \EOF
  14warn () {
  15        echo "$*" >&2
  16}
  17
  18map()
  19{
  20        # if it was not rewritten, take the original
  21        if test -r "$workdir/../map/$1"
  22        then
  23                cat "$workdir/../map/$1"
  24        else
  25                echo "$1"
  26        fi
  27}
  28
  29# if you run 'skip_commit "$@"' in a commit filter, it will print
  30# the (mapped) parents, effectively skipping the commit.
  31
  32skip_commit()
  33{
  34        shift;
  35        while [ -n "$1" ];
  36        do
  37                shift;
  38                map "$1";
  39                shift;
  40        done;
  41}
  42
  43# if you run 'git_commit_non_empty_tree "$@"' in a commit filter,
  44# it will skip commits that leave the tree untouched, commit the other.
  45git_commit_non_empty_tree()
  46{
  47        if test $# = 3 && test "$1" = $(git rev-parse "$3^{tree}"); then
  48                map "$3"
  49        else
  50                git commit-tree "$@"
  51        fi
  52}
  53# override die(): this version puts in an extra line break, so that
  54# the progress is still visible
  55
  56die()
  57{
  58        echo >&2
  59        echo "$*" >&2
  60        exit 1
  61}
  62EOF
  63)
  64
  65eval "$functions"
  66
  67# When piped a commit, output a script to set the ident of either
  68# "author" or "committer
  69
  70set_ident () {
  71        lid="$(echo "$1" | tr "[A-Z]" "[a-z]")"
  72        uid="$(echo "$1" | tr "[a-z]" "[A-Z]")"
  73        pick_id_script='
  74                /^'$lid' /{
  75                        s/'\''/'\''\\'\'\''/g
  76                        h
  77                        s/^'$lid' \([^<]*\) <[^>]*> .*$/\1/
  78                        s/'\''/'\''\'\'\''/g
  79                        s/.*/GIT_'$uid'_NAME='\''&'\''; export GIT_'$uid'_NAME/p
  80
  81                        g
  82                        s/^'$lid' [^<]* <\([^>]*\)> .*$/\1/
  83                        s/'\''/'\''\'\'\''/g
  84                        s/.*/GIT_'$uid'_EMAIL='\''&'\''; export GIT_'$uid'_EMAIL/p
  85
  86                        g
  87                        s/^'$lid' [^<]* <[^>]*> \(.*\)$/\1/
  88                        s/'\''/'\''\'\'\''/g
  89                        s/.*/GIT_'$uid'_DATE='\''&'\''; export GIT_'$uid'_DATE/p
  90
  91                        q
  92                }
  93        '
  94
  95        LANG=C LC_ALL=C sed -ne "$pick_id_script"
  96        # Ensure non-empty id name.
  97        echo "case \"\$GIT_${uid}_NAME\" in \"\") GIT_${uid}_NAME=\"\${GIT_${uid}_EMAIL%%@*}\" && export GIT_${uid}_NAME;; esac"
  98}
  99
 100USAGE="[--env-filter <command>] [--tree-filter <command>]
 101        [--index-filter <command>] [--parent-filter <command>]
 102        [--msg-filter <command>] [--commit-filter <command>]
 103        [--tag-name-filter <command>] [--subdirectory-filter <directory>]
 104        [--original <namespace>] [-d <directory>] [-f | --force]
 105        [<rev-list options>...]"
 106
 107OPTIONS_SPEC=
 108. git-sh-setup
 109
 110if [ "$(is_bare_repository)" = false ]; then
 111        require_clean_work_tree 'rewrite branches'
 112fi
 113
 114tempdir=.git-rewrite
 115filter_env=
 116filter_tree=
 117filter_index=
 118filter_parent=
 119filter_msg=cat
 120filter_commit=
 121filter_tag_name=
 122filter_subdir=
 123orig_namespace=refs/original/
 124force=
 125prune_empty=
 126remap_to_ancestor=
 127while :
 128do
 129        case "$1" in
 130        --)
 131                shift
 132                break
 133                ;;
 134        --force|-f)
 135                shift
 136                force=t
 137                continue
 138                ;;
 139        --remap-to-ancestor)
 140                # deprecated ($remap_to_ancestor is set now automatically)
 141                shift
 142                remap_to_ancestor=t
 143                continue
 144                ;;
 145        --prune-empty)
 146                shift
 147                prune_empty=t
 148                continue
 149                ;;
 150        -*)
 151                ;;
 152        *)
 153                break;
 154        esac
 155
 156        # all switches take one argument
 157        ARG="$1"
 158        case "$#" in 1) usage ;; esac
 159        shift
 160        OPTARG="$1"
 161        shift
 162
 163        case "$ARG" in
 164        -d)
 165                tempdir="$OPTARG"
 166                ;;
 167        --env-filter)
 168                filter_env="$OPTARG"
 169                ;;
 170        --tree-filter)
 171                filter_tree="$OPTARG"
 172                ;;
 173        --index-filter)
 174                filter_index="$OPTARG"
 175                ;;
 176        --parent-filter)
 177                filter_parent="$OPTARG"
 178                ;;
 179        --msg-filter)
 180                filter_msg="$OPTARG"
 181                ;;
 182        --commit-filter)
 183                filter_commit="$functions; $OPTARG"
 184                ;;
 185        --tag-name-filter)
 186                filter_tag_name="$OPTARG"
 187                ;;
 188        --subdirectory-filter)
 189                filter_subdir="$OPTARG"
 190                remap_to_ancestor=t
 191                ;;
 192        --original)
 193                orig_namespace=$(expr "$OPTARG/" : '\(.*[^/]\)/*$')/
 194                ;;
 195        *)
 196                usage
 197                ;;
 198        esac
 199done
 200
 201case "$prune_empty,$filter_commit" in
 202,)
 203        filter_commit='git commit-tree "$@"';;
 204t,)
 205        filter_commit="$functions;"' git_commit_non_empty_tree "$@"';;
 206,*)
 207        ;;
 208*)
 209        die "Cannot set --prune-empty and --commit-filter at the same time"
 210esac
 211
 212case "$force" in
 213t)
 214        rm -rf "$tempdir"
 215;;
 216'')
 217        test -d "$tempdir" &&
 218                die "$tempdir already exists, please remove it"
 219esac
 220mkdir -p "$tempdir/t" &&
 221tempdir="$(cd "$tempdir"; pwd)" &&
 222cd "$tempdir/t" &&
 223workdir="$(pwd)" ||
 224die ""
 225
 226# Remove tempdir on exit
 227trap 'cd ../..; rm -rf "$tempdir"' 0
 228
 229ORIG_GIT_DIR="$GIT_DIR"
 230ORIG_GIT_WORK_TREE="$GIT_WORK_TREE"
 231ORIG_GIT_INDEX_FILE="$GIT_INDEX_FILE"
 232GIT_WORK_TREE=.
 233export GIT_DIR GIT_WORK_TREE
 234
 235# Make sure refs/original is empty
 236git for-each-ref > "$tempdir"/backup-refs || exit
 237while read sha1 type name
 238do
 239        case "$force,$name" in
 240        ,$orig_namespace*)
 241                die "Cannot create a new backup.
 242A previous backup already exists in $orig_namespace
 243Force overwriting the backup with -f"
 244        ;;
 245        t,$orig_namespace*)
 246                git update-ref -d "$name" $sha1
 247        ;;
 248        esac
 249done < "$tempdir"/backup-refs
 250
 251# The refs should be updated if their heads were rewritten
 252git rev-parse --no-flags --revs-only --symbolic-full-name \
 253        --default HEAD "$@" > "$tempdir"/raw-heads || exit
 254sed -e '/^^/d' "$tempdir"/raw-heads >"$tempdir"/heads
 255
 256test -s "$tempdir"/heads ||
 257        die "Which ref do you want to rewrite?"
 258
 259GIT_INDEX_FILE="$(pwd)/../index"
 260export GIT_INDEX_FILE
 261
 262# map old->new commit ids for rewriting parents
 263mkdir ../map || die "Could not create map/ directory"
 264
 265# we need "--" only if there are no path arguments in $@
 266nonrevs=$(git rev-parse --no-revs "$@") || exit
 267if test -z "$nonrevs"
 268then
 269        dashdash=--
 270else
 271        dashdash=
 272        remap_to_ancestor=t
 273fi
 274
 275rev_args=$(git rev-parse --revs-only "$@")
 276
 277case "$filter_subdir" in
 278"")
 279        eval set -- "$(git rev-parse --sq --no-revs "$@")"
 280        ;;
 281*)
 282        eval set -- "$(git rev-parse --sq --no-revs "$@" $dashdash \
 283                "$filter_subdir")"
 284        ;;
 285esac
 286
 287git rev-list --reverse --topo-order --default HEAD \
 288        --parents --simplify-merges $rev_args "$@" > ../revs ||
 289        die "Could not get the commits"
 290commits=$(wc -l <../revs | tr -d " ")
 291
 292test $commits -eq 0 && die "Found nothing to rewrite"
 293
 294# Rewrite the commits
 295
 296git_filter_branch__commit_count=0
 297while read commit parents; do
 298        git_filter_branch__commit_count=$(($git_filter_branch__commit_count+1))
 299        printf "\rRewrite $commit ($git_filter_branch__commit_count/$commits)"
 300
 301        case "$filter_subdir" in
 302        "")
 303                git read-tree -i -m $commit
 304                ;;
 305        *)
 306                # The commit may not have the subdirectory at all
 307                err=$(git read-tree -i -m $commit:"$filter_subdir" 2>&1) || {
 308                        if ! git rev-parse -q --verify $commit:"$filter_subdir"
 309                        then
 310                                rm -f "$GIT_INDEX_FILE"
 311                        else
 312                                echo >&2 "$err"
 313                                false
 314                        fi
 315                }
 316        esac || die "Could not initialize the index"
 317
 318        GIT_COMMIT=$commit
 319        export GIT_COMMIT
 320        git cat-file commit "$commit" >../commit ||
 321                die "Cannot read commit $commit"
 322
 323        eval "$(set_ident AUTHOR <../commit)" ||
 324                die "setting author failed for commit $commit"
 325        eval "$(set_ident COMMITTER <../commit)" ||
 326                die "setting committer failed for commit $commit"
 327        eval "$filter_env" < /dev/null ||
 328                die "env filter failed: $filter_env"
 329
 330        if [ "$filter_tree" ]; then
 331                git checkout-index -f -u -a ||
 332                        die "Could not checkout the index"
 333                # files that $commit removed are now still in the working tree;
 334                # remove them, else they would be added again
 335                git clean -d -q -f -x
 336                eval "$filter_tree" < /dev/null ||
 337                        die "tree filter failed: $filter_tree"
 338
 339                (
 340                        git diff-index -r --name-only --ignore-submodules $commit &&
 341                        git ls-files --others
 342                ) > "$tempdir"/tree-state || exit
 343                git update-index --add --replace --remove --stdin \
 344                        < "$tempdir"/tree-state || exit
 345        fi
 346
 347        eval "$filter_index" < /dev/null ||
 348                die "index filter failed: $filter_index"
 349
 350        parentstr=
 351        for parent in $parents; do
 352                for reparent in $(map "$parent"); do
 353                        parentstr="$parentstr -p $reparent"
 354                done
 355        done
 356        if [ "$filter_parent" ]; then
 357                parentstr="$(echo "$parentstr" | eval "$filter_parent")" ||
 358                                die "parent filter failed: $filter_parent"
 359        fi
 360
 361        sed -e '1,/^$/d' <../commit | \
 362                eval "$filter_msg" > ../message ||
 363                        die "msg filter failed: $filter_msg"
 364        workdir=$workdir @SHELL_PATH@ -c "$filter_commit" "git commit-tree" \
 365                $(git write-tree) $parentstr < ../message > ../map/$commit ||
 366                        die "could not write rewritten commit"
 367done <../revs
 368
 369# If we are filtering for paths, as in the case of a subdirectory
 370# filter, it is possible that a specified head is not in the set of
 371# rewritten commits, because it was pruned by the revision walker.
 372# Ancestor remapping fixes this by mapping these heads to the unique
 373# nearest ancestor that survived the pruning.
 374
 375if test "$remap_to_ancestor" = t
 376then
 377        while read ref
 378        do
 379                sha1=$(git rev-parse "$ref"^0)
 380                test -f "$workdir"/../map/$sha1 && continue
 381                ancestor=$(git rev-list --simplify-merges -1 "$ref" "$@")
 382                test "$ancestor" && echo $(map $ancestor) >> "$workdir"/../map/$sha1
 383        done < "$tempdir"/heads
 384fi
 385
 386# Finally update the refs
 387
 388_x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
 389_x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
 390echo
 391while read ref
 392do
 393        # avoid rewriting a ref twice
 394        test -f "$orig_namespace$ref" && continue
 395
 396        sha1=$(git rev-parse "$ref"^0)
 397        rewritten=$(map $sha1)
 398
 399        test $sha1 = "$rewritten" &&
 400                warn "WARNING: Ref '$ref' is unchanged" &&
 401                continue
 402
 403        case "$rewritten" in
 404        '')
 405                echo "Ref '$ref' was deleted"
 406                git update-ref -m "filter-branch: delete" -d "$ref" $sha1 ||
 407                        die "Could not delete $ref"
 408        ;;
 409        $_x40)
 410                echo "Ref '$ref' was rewritten"
 411                if ! git update-ref -m "filter-branch: rewrite" \
 412                                        "$ref" $rewritten $sha1 2>/dev/null; then
 413                        if test $(git cat-file -t "$ref") = tag; then
 414                                if test -z "$filter_tag_name"; then
 415                                        warn "WARNING: You said to rewrite tagged commits, but not the corresponding tag."
 416                                        warn "WARNING: Perhaps use '--tag-name-filter cat' to rewrite the tag."
 417                                fi
 418                        else
 419                                die "Could not rewrite $ref"
 420                        fi
 421                fi
 422        ;;
 423        *)
 424                # NEEDSWORK: possibly add -Werror, making this an error
 425                warn "WARNING: '$ref' was rewritten into multiple commits:"
 426                warn "$rewritten"
 427                warn "WARNING: Ref '$ref' points to the first one now."
 428                rewritten=$(echo "$rewritten" | head -n 1)
 429                git update-ref -m "filter-branch: rewrite to first" \
 430                                "$ref" $rewritten $sha1 ||
 431                        die "Could not rewrite $ref"
 432        ;;
 433        esac
 434        git update-ref -m "filter-branch: backup" "$orig_namespace$ref" $sha1 ||
 435                 exit
 436done < "$tempdir"/heads
 437
 438# TODO: This should possibly go, with the semantics that all positive given
 439#       refs are updated, and their original heads stored in refs/original/
 440# Filter tags
 441
 442if [ "$filter_tag_name" ]; then
 443        git for-each-ref --format='%(objectname) %(objecttype) %(refname)' refs/tags |
 444        while read sha1 type ref; do
 445                ref="${ref#refs/tags/}"
 446                # XXX: Rewrite tagged trees as well?
 447                if [ "$type" != "commit" -a "$type" != "tag" ]; then
 448                        continue;
 449                fi
 450
 451                if [ "$type" = "tag" ]; then
 452                        # Dereference to a commit
 453                        sha1t="$sha1"
 454                        sha1="$(git rev-parse -q "$sha1"^{commit})" || continue
 455                fi
 456
 457                [ -f "../map/$sha1" ] || continue
 458                new_sha1="$(cat "../map/$sha1")"
 459                GIT_COMMIT="$sha1"
 460                export GIT_COMMIT
 461                new_ref="$(echo "$ref" | eval "$filter_tag_name")" ||
 462                        die "tag name filter failed: $filter_tag_name"
 463
 464                echo "$ref -> $new_ref ($sha1 -> $new_sha1)"
 465
 466                if [ "$type" = "tag" ]; then
 467                        new_sha1=$( ( printf 'object %s\ntype commit\ntag %s\n' \
 468                                                "$new_sha1" "$new_ref"
 469                                git cat-file tag "$ref" |
 470                                sed -n \
 471                                    -e '1,/^$/{
 472                                          /^object /d
 473                                          /^type /d
 474                                          /^tag /d
 475                                        }' \
 476                                    -e '/^-----BEGIN PGP SIGNATURE-----/q' \
 477                                    -e 'p' ) |
 478                                git mktag) ||
 479                                die "Could not create new tag object for $ref"
 480                        if git cat-file tag "$ref" | \
 481                           sane_grep '^-----BEGIN PGP SIGNATURE-----' >/dev/null 2>&1
 482                        then
 483                                warn "gpg signature stripped from tag object $sha1t"
 484                        fi
 485                fi
 486
 487                git update-ref "refs/tags/$new_ref" "$new_sha1" ||
 488                        die "Could not write tag $new_ref"
 489        done
 490fi
 491
 492cd ../..
 493rm -rf "$tempdir"
 494
 495trap - 0
 496
 497unset GIT_DIR GIT_WORK_TREE GIT_INDEX_FILE
 498test -z "$ORIG_GIT_DIR" || {
 499        GIT_DIR="$ORIG_GIT_DIR" && export GIT_DIR
 500}
 501test -z "$ORIG_GIT_WORK_TREE" || {
 502        GIT_WORK_TREE="$ORIG_GIT_WORK_TREE" &&
 503        export GIT_WORK_TREE
 504}
 505test -z "$ORIG_GIT_INDEX_FILE" || {
 506        GIT_INDEX_FILE="$ORIG_GIT_INDEX_FILE" &&
 507        export GIT_INDEX_FILE
 508}
 509
 510if [ "$(is_bare_repository)" = false ]; then
 511        git read-tree -u -m HEAD || exit
 512fi
 513
 514exit 0